# Trigger

A class that implements this interface can be used as a trigger.

Methods
void | close() This method is called when the database is closed.
void | close() throws SQLException This method is called when the database is closed. If the method throws an exception, it will be logged, but closing the database will continue.
void | fire(Connection conn, Object[] oldRow, Object[] newRow) This method is called for each triggered action.

void

fire(Connection conn, Object[] oldRow, Object[] newRow) throws SQLException
This method is called for each triggered action. The method is called immediately when the operation occurred (before it is committed). A transaction rollback will also rollback the operations that were done within the trigger, if the operations occurred within the same database. If the trigger changes state outside the database, a rollback trigger should be used.

The row arrays contain all columns of the table, in the same order as defined in the table.

The trigger itself may change the data in the newRow array.

Parameters:
conn - a connection to the database
oldRow - the old row, or null if no old row is available (for INSERT)
newRow - the new row, or null if no new row is available (for DELETE)
Throws:
SQLException - if the operation must be undone

void | init(Connection conn, String schemaName, String triggerName, String tableName, boolean before, int type) This method is called by the database engine once when initializing the trigger.

void

init(Connection conn, String schemaName, String triggerName, String tableName, boolean before, int type) throws SQLException
This method is called by the database engine once when initializing the trigger. It is called when the trigger is created, as well as when the database is opened. The type of operation is a bit field with the appropriate flags set. As an example, if the trigger is of type INSERT and UPDATE, then the parameter type is set to (INSERT | UPDATE).
Parameters:
conn - a connection to the database (a system connection)
schemaName - the name of the schema
triggerName - the name of the trigger used in the CREATE TRIGGER statement
tableName - the name of the table
before - whether the fire method is called before or after the operation is performed
type - the operation type: INSERT, UPDATE, DELETE, SELECT, or a combination (this parameter is a bit field)

void | remove() This method is called when the trigger is dropped.
void | remove() throws SQLException This method is called when the trigger is dropped.

Fields
static int | DELETE = 4
static int | INSERT = 1
static int | SELECT = 8
static int | UPDATE = 2

#### INSERT = 1

The trigger is called for INSERT statements.

#### UPDATE = 2

The trigger is called for UPDATE statements.

#### DELETE = 4

The trigger is called for DELETE statements.

#### SELECT = 8

The trigger is called for SELECT statements.